package info.kramann.mikro3;


public class Mikro3 extends Zwischenschicht 
{
    public Mikrofon mikrofon;
    public boolean aktiv = false;
    public short[] data;
    public void setup()
    {
    	  orientation(LANDSCAPE);
    	  mikrofon = new Mikrofon(this);
    }

    public void draw()
    {
         clear();
         background(255);
         noStroke();
         if(aktiv)
         {
               fill(0,255,0);
         }
         else
         {
               fill(255,0,0);
         }
         ellipse(width/2,height/2,width/2,height/2);
         
         stroke(0,0,255);
         if (data != null)
         {  
           for (int i = 0; i < data.length; i++)
           {
             if(i != data.length-1)
                  line(i, map(data[i], -32768, 32767,height,0), i+1, map(data[i+1], -32768, 32767,height,0));
           }
         }
         
    }

    public void onAudioEvent(short[] _data)
    {
      data= _data;
    }
    
    public void mousePressed()
    {
        if (mikrofon.isActive())
        {
            mikrofon.stop();
            aktiv = false;
        }
        else
        {
            mikrofon.start();
            aktiv = true;
        }
    }
}
