package processing.test.sinuston3;

import processing.core.*; 

import android.media.AudioTrack;
import android.media.AudioFormat;
import android.media.AudioManager;


public class sinuston3 extends PApplet 
{

boolean aktiv = false; 

int sr;
int buffsize;

//create an audiotrack object
AudioTrack audioTrack;


short[] samples;
int amp = 10000;
float twopi = 2.0f*PI;
float fr = 440.0f;
float fr2 = 4.4f;
float fr4 = 1.1f;
float fr3 = 220.0f;
float ph = 0.0f;   
float ph2 = 0.0f;   
float ph3 = 0.0f;   
float ph4 = 0.0f;   
float change=0.0f;
float change2=0.0f;

Tonspieler tonspieler;

public void setup()
{
	sr = 44100;

	buffsize = AudioTrack.getMinBufferSize(sr, AudioFormat.CHANNEL_OUT_MONO, 
	        AudioFormat.ENCODING_PCM_16BIT);

	//create an audiotrack object
	audioTrack = new AudioTrack(AudioManager.STREAM_MUSIC, sr, 
	                                    AudioFormat.CHANNEL_OUT_MONO, 
	                                    AudioFormat.ENCODING_PCM_16BIT, 
	                                    buffsize, 
	                                    AudioTrack.MODE_STREAM);


	samples= new short[buffsize];
   
	tonspieler = new Tonspieler();
	
	Thread t = new Thread(tonspieler);
	t.start();
	audioTrack.play();
}

public void draw()
{
    clear();
    background(0);
    if(aktiv)    
        fill(0,255,0);
    else
        fill(255,0,0);    
    ellipse(width/2,height/2,width/2,height/2);
}

public void mousePressed()
{
    aktiv = !aktiv;
}

private class Tonspieler implements Runnable
{
	public void run()
	{
		while(true)
		{
			if(aktiv)
			{
				  for(int i=0;i<buffsize;i++)
				  {  
					samples[i] = (short) (amp*sin(ph)  + amp*sin(ph3));
				     ph += twopi*(fr+change)/sr;
				     ph3 += twopi*(fr3+change2)/sr;
				     ph2 += twopi*fr2/sr;
				     ph4 += twopi*fr4/sr;
				     change = 50.0f*(1.0f+sin(ph2));
				     change2 = 50.0f*(1.0f+sin(ph4));
				  } 
				  audioTrack.write(samples, 0, buffsize);
				
			}
		}
	}
}
}


